﻿using Infragistics.Win.UltraWinListView;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraListViewSortByChecked
{
    public partial class Form1 : Form
    {
        List<UltraListViewItem> items = new List<UltraListViewItem>();
        public Form1()
        {
            InitializeComponent();

            ultraListView1.View = Infragistics.Win.UltraWinListView.UltraListViewStyle.List;      
            ultraListView1.ViewSettingsList.CheckBoxStyle = Infragistics.Win.UltraWinListView.CheckBoxStyle.CheckBox;
            
            for(int i=10; i>0; i--)
            {
                UltraListViewItem item = new UltraListViewItem() { Key = i.ToString(), Value = "Item " + i.ToString() };
                items.Add(item);
                ultraListView1.Items.Add(i.ToString(), "Item " + i.ToString());
            }                        
        }


        bool isCheckSortDescending = false;
        private void ultraButton1_Click(object sender, EventArgs e)
        {           
            List<UltraListViewItem> checkedItems = new List<UltraListViewItem>();
            List<UltraListViewItem> uncheckedItems = new List<UltraListViewItem>();

            for(int i=0; i<ultraListView1.Items.Count; i++)
            {
                if(ultraListView1.Items[i].CheckState == CheckState.Checked)
                {
                    checkedItems.Add(ultraListView1.Items[i]);
                }
                else
                {
                    uncheckedItems.Add(ultraListView1.Items[i]);
                }
            }

            ultraListView1.Items.Clear();

            if (isCheckSortDescending)
            {
                for(int i=0; i<uncheckedItems.Count; i++)
                {
                    UltraListViewItem item = uncheckedItems[i];
                    item.CheckState = CheckState.Unchecked;
                    ultraListView1.Items.Add(item);
                }

                for (int i = 0; i < checkedItems.Count; i++)
                {
                    UltraListViewItem item = checkedItems[i];
                    item.CheckState = CheckState.Checked;
                    ultraListView1.Items.Add(item);
                }
            }
            else
            {
                for(int i=0; i<checkedItems.Count; i++)
                {
                    UltraListViewItem item = checkedItems[i];
                    item.CheckState = CheckState.Checked;
                    ultraListView1.Items.Add(item);
                }

                for (int i = 0; i < uncheckedItems.Count; i++)
                {
                    UltraListViewItem item = uncheckedItems[i];
                    item.CheckState = CheckState.Unchecked;
                    ultraListView1.Items.Add(item);
                }
            }

            isCheckSortDescending = !isCheckSortDescending;
        }
    }
}
